## Copyright (C) 2000, 2001, 2002  SWsoft
## All rights reserved.
## Abstract visual base class for plugins
package HSPC::PluginConfig::Abstract;

use HSPC::WebSystemLib;
use strict;

use HSPC::Logger qw(sw_die sw_log);

my @LAYOUT = ();

sub new {
	my $this = shift;
	my $class = ref($this) || $this;
	my $self;
	$self->{layout} = [];
	bless ($self, $class);
	return $self;
}

sub process {
	my $class = shift;
	my %h = (
		page => undef,
		@_
	);
	my $page     = $h{page};
	my $sub_type = $h{sub_type};
	my $self = $class->new();
	$self->{plugin_sub_type} = $h{sub_type};
	my $id  = sw_argparam("id")  || sw_uriparam('id');
	my $act = sw_argparam("act") || sw_uriparam('act');
	$page->title(pages => [], refresh_url => $ENV{COMPREP}->link(sw_uriparams()));
	$self->{page}     = $page;
	my $obj = HSPC::MT::PluginConfig->find_plugin(
		id             => $id,
		vendor_id      => $ENV{security_obj}->account_no(),
		force_activity => 1,
	) if $id;
	$self->{obj} = $obj;
	if ($act eq 'new') {
		return $self->process_wizard(page => $page, start => 1, sub_type => $sub_type );
	} elsif ($act eq 'wizard') {
		return $self->process_wizard( page => $page);
	} elsif ($act eq  'view') {
		$self->view();
	} elsif ($act eq 'edit'){
		$self->edit();
	} elsif ($act eq 'update'){
		$self->update();
	} else {
		$self->list(page => $page);
	}
	return  {STATUS=>($page->{status} || 'OK'),CONTENT=>$page->{edit_out}};
}

1;
